import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.FlushModeType;
import javax.persistence.Persistence;
import javax.persistence.Query;

public class Main {
  static EntityManagerFactory emf = Persistence.createEntityManagerFactory("JPAService");

  static EntityManager em = emf.createEntityManager();

  public static void main(String[] a) throws Exception {
    em.getTransaction().begin();

    List<Conversation> active = (List<Conversation>) em.createNamedQuery("findActiveConversations")
        .getResultList();
    Query maxAge = em.createNamedQuery("findLastMessageDate");
    maxAge.setFlushMode(FlushModeType.COMMIT);
    for (Conversation c : active) {
      maxAge.setParameter("conversation", c);
      Date lastMessageDate = (Date) maxAge.getSingleResult();
      if (lastMessageDate.before(new Date())) {
        c.setStatus("INACTIVE");
      }
    }

    em.getTransaction().commit();
    em.close();
    emf.close();

    Helper.checkData();
  }
}